require "us"

explodeRate = 20
explodeSize = 50

function love.load()
	us.bases.left = us.addBase()
	us.bases.right = us.addBase()
	if us.bases.left.x > us.bases.right.x then
		us.bases.left, us.bases.right = us.bases.right, us.bases.left
	end
	
	explosions = {}

	trailImg = love.graphics.newImage('fire.png')
end

function love.update(dt)
	if love.mouse.isDown(1) then
		us.bases.left:fire()
	end
	if love.mouse.isDown(2) then
		us.bases.right:fire()
	end

	for _,b in pairs(us.bases) do
		b.cooldown = b.cooldown - 1
	end
	
	for i,b in pairs(us.bullets) do
		if (b.vx > 0 and b.x >= b.tx) or (b.vx < 0 and b.x < b.tx) then
			us:explode(b.x,b.y)
			table.remove(us.bullets, i)
		elseif (b.vy > 0 and b.y >= b.ty) or (b.vy < 0 and b.y < b.ty) then
			us:explode(b.x,b.y)
			table.remove(us.bullets, i)
		end
		--[[
		if b.x < -20 or b.x > love.graphics.getWidth() + 20 then
			table.remove(us.bullets, i)
		end
		if b.y < -20 or b.y > love.graphics.getHeight() + 20 then
			table.remove(us.bullets, i)
		end
		]]--
		b.x = b.x + b.vx*dt
		b.y = b.y + b.vy*dt
		b.trail:update(dt)
	end

	for i,e in pairs(explosions) do
		if e.embiggening then
			e.rad = e.rad + explodeRate * dt
			if e.rad >= explodeSize then
				e.embiggening = false
			end
		else
			e.rad = e.rad - explodeRate * dt
			if e.rad <= 0 then
				table.remove(explosions, i)
			end
		end
	end
end

local function drawStencil()
	for _,e in pairs(explosions) do
		love.graphics.circle("fill", e.x, e.y, e.rad, 32)
	end
end

function love.draw()
	love.graphics.setBackgroundColor(0,128,255)
	love.graphics.setColor(255,255,255)
	for _,b in pairs(us.bases) do
		love.graphics.circle("fill", b.x, b.y, 20, 6)
	end
	for _,b in pairs(us.bullets) do
		love.graphics.setColor(255,255,255)
		love.graphics.draw(b.trail, b.x, b.y)
		love.graphics.setColor(255,0,0)
		love.graphics.circle("fill", b.x, b.y, 5, 8)
	end
	
	love.graphics.stencil(drawStencil, "increment") -- This increments and clears the previous frame's the shader buffer (think of it as a depth buffer) in the circle's region by 1
	
	love.graphics.setStencilTest("lequal", 1) -- Only allow rendering on pixels which have a stencil value less than or equal to 1 (not in intersection).
	love.graphics.setColor(255,255,0)
	for _,e in pairs(explosions) do
		love.graphics.circle("fill", e.x, e.y, e.rad, 32)
	end
	
    love.graphics.setStencilTest("greater", 1) -- Only allow rendering on pixels which have a stencil value greater than 1 (in intersection).
	love.graphics.setColor(0,255,0)
	for _,e in pairs(explosions) do
		love.graphics.circle("fill", e.x, e.y, e.rad, 32)
	end
end
