us = {}

us.bulletSpeed = 20
us.cooldown = 10

us.bases = {}
us.bullets = {}

function us:addBase()
	base = {}
	base.x = love.math.random( love.graphics.getWidth() )
	base.y = love.math.random( love.graphics.getHeight() )
	base.cooldown = 10
	base.bulletSpeed = 200

	function base:fire()
		if self.cooldown <= 0 then
			self.cooldown = 10
			bullet = {}
			bullet.x = self.x
			bullet.y = self.y
			bullet.tx, bullet.ty = love.mouse.getPosition()
			local dx = bullet.tx - bullet.x
			local dy = bullet.ty - bullet.y
			local h = math.sqrt(dx^2 + dy^2)
			local dh = self.bulletSpeed / h
			bullet.vx = dx * dh
			bullet.vy = dy * dh
			bullet.trail = love.graphics.newParticleSystem(trailImg, 32)
			bullet.trail:setParticleLifetime(2, 5)
			bullet.trail:setEmissionRate(10)
			bullet.trail:setSizeVariation(1)
			bullet.trail:setDirection(math.atan2(-bullet.vy,-bullet.vx))
			bullet.trail:setSpeed(self.bulletSpeed-25,self.bulletSpeed+25)
			bullet.trail:setLinearAcceleration( -50, -50, 50, 50 )
			bullet.trail:setColors(255, 255, 255, 255, 255, 255, 255, 0)
			table.insert(us.bullets, bullet)
		end
	end

	return base
end

function us:explode(x,y)
	e = {}
	e.x = x
	e.y = y
	e.rad = 0
	e.embiggening = true
	table.insert(explosions, e)
end
